// ==UserScript==
// @name           JupiterPlus
// @namespace      JupiterPlus
// @description    Melhora a visualizacao da grade horaria no site Jupiter USP
// @include        https://uspdigital.usp.br/jupiterweb/*
// ==/UserScript==
// (c)2008 Felipe Sanches <felipe.sanches@poli.usp.br>
// (c)2012 Diego Rabatone Oliveira <diraol@diraol.eng.br>
// This program is licensed under the GNU General Public License version 3 or later.
// Este programa está licenciado sob a Licença Pública Geral GNU (GPL) versão 3 ou posterior.
// Oferecimento: PoliGNU - http://polignu.org

//Parâmetros básicos
LARGURA=95
ALTURA=40

//Definindo funções

//Função que converte o horário em pixels
function timestr_to_pixels(str){
    var v = str.split(":")
    var res
    res = parseFloat(v[0]) + parseFloat(v[1])/60 - 8
    return Math.floor(ALTURA * res)
}

cor_da_materia = {}
cor_usada = {}

//recebe valor numerico e retorna codigo de cor no formato "#rgb"
function cor(str){
    if (cor_da_materia[str])
        return cor_da_materia[str]

    var valor
    do{
        valor = Math.floor(Math.random()*27)
    } while(cor_usada[valor])
    cor_usada[valor] = true

        // se vc mudar esses números vc terá uma paleta de cores diferente:
    var codigo = new Array
    codigo[0] = "a"
    codigo[1] = "c"
    codigo[2] = "e"

    var ret = ""
    for (var i=0; i<3; i++){
        ret = codigo[valor % 3] + ret
        valor = Math.floor(valor/3)
    }

    cor_da_materia[str] = "#" + ret
    return "#" + ret
}

//Função que formatará o conteúdo da div (exceto horário) da forma como quiser.
function formata_disciplina(html){
    return html
}

//Função que retorna true se a diferença de horários for maior que 1 hora
	//e retorna false se a diferença for menor que 1 hora
function diferenca_de_horarios(horario1, horario2){
	//transformando em minutos
	//console.log(horario1.split(":")[0]/60)
	var h1 = horario1.split(":")[0]*60 + horario1.split(":")[1]
	var h2 = horario2.split(":")[0]*60 + horario2.split(":")[1]
	var diferenca = Math.abs(h1 - h2)
	if (diferenca > 60)
		return true
	else
		return false
}

//Escolhe uma cor e chama a função que adiciona uma disciplina
function adiciona_evento(referencia, dia, i, f, h){
	if (diferenca_de_horarios(i,f))
		adiciona_div(referencia, dia, i, f, h, cor(h), true, true)
	else
		adiciona_div(referencia, dia, i, f, h, cor(h), true, false)
}

//Adiciona uma disciplina
function adiciona_div(referencia, dia, i, f, h, cor, indicar_hora_inicio, indicar_hora_fim){
    var i_px = timestr_to_pixels(i); //horário de inicio
    var f_px = timestr_to_pixels(f); //horário de término
    var altura = f_px - i_px;//altura referente à duração da aula
    var mydiv = document.createElement('div')
    if(indicar_hora_inicio && indicar_hora_fim){
        mydiv.innerHTML = "<font size=1>"+i+"</font>" + h +
          "<div style='width:" + LARGURA * 0.8 + "px;" +
                      "text-align: right;" +
                      "position:absolute; top:" + ( altura -13 ) + "px;'>" +
                "<font size=1>"+f+"</font>" +
          "</div>"
	} else if (indicar_hora_inicio) {
		mydiv.innerHTML = "<font size=1>"+i+"</font>" + h
	} else if (indicar_hora_fim) {
		mydiv.innerHTML = h +
          "<div style='width:" + LARGURA * 0.8 + "px;" +
                      "text-align: right;" +
                      "position:absolute; top:" + ( altura -13 ) + "px;'>" +
                "<font size=1>"+f+"</font>" +
          "</div>"
	} else if (!indicar_hora_inicio && !indicar_hora_fim) {
        mydiv.innerHTML = h
    }
    mydiv.style.width = 0.8 * LARGURA + "px"
    mydiv.style.position = "absolute"
    mydiv.style.top = i_px + 40 + "px"
    mydiv.style.left = LARGURA * (dia + 0.4) + "px";// + i_px/10
    mydiv.style.height = f_px - i_px + "px"
    mydiv.style.border = "thin solid"
    mydiv.style.backgroundColor = cor

    referencia.appendChild(mydiv)
}

//Cria o tracejado baseado apenas em HORA, não considera MINUTOS
//os valores i e f devem ser dois 'inteiros'
function tracejado_horas(i,f){
	i = i-1
    for (var h=i+1;h<=f;h++){
        //cria a div com o texto do horário para o começo da linha
        var mydivhora = document.createElement('div')
        mydivhora.style.border = "none"
        mydivhora.style.left = LARGURA * 0.1 + "px"
        mydivhora.style.top = timestr_to_pixels(h+1+":00")-9 + "px" //-9 server para ajustar o número no centro da linha tracejada
        mydivhora.style.position = "absolute"
        mydivhora.style.fontSize = "12px"
        mydivhora.innerHTML = h
        //cria a div da linha pontilhada
        var mydiv = document.createElement('div')
        mydiv.style.heigth="1px"
        mydiv.style.border = "thin dashed #ddd"
        mydiv.style.left = LARGURA * 0.4 + "px"
        mydiv.style.top = timestr_to_pixels(h+1+":00") + "px"
        mydiv.style.width = LARGURA * 5.8 + "px"
        mydiv.style.position = "absolute"
        mydiv.style.zindex = "-1"
        //adiciona as duas divs criadas.
        nova_grade.appendChild(mydivhora)
        nova_grade.appendChild(mydiv)
    }
}

//Esta função comparará dois horários que serão passados no formato hora:minuto
//Ela retornará o menor horário se menor = 1 ou o maior horário caso menor = 0
function compara_horas(h1,h2,menor){

    hora_h1 = h1.substr(0,2)*60
    minuto_h1 = h1.substr(3,2)

    hora_h2 = h2.substr(0,2)*60
    minuto_h2 = h2.substr(3,2)

    //retorna o menor horário
    if (menor){
        if(hora_h1 < hora_h2){
            return h1
        } else if (hora_h1 > hora_h2){
            return h2
        } else if (minuto_h1 < minuto_h2){
            return h1
        } else {
            return h2
        }
    } else { //retnorna o maior horário
        if(hora_h1 > hora_h2){
            return h1
        } else if (hora_h1 < hora_h2){
            return h2
        } else if (minuto_h1 > minuto_h2){
            return h1
        } else {
            return h2
        }
    }
}

//Função que subtrai ou adiciona minutos ao horário passado
//Caso adiciona seja 1 ele adiciona os minutos, caso adiciona seja 0 ele subtrai
function adicionaMinutos(horario,minutosAdd){
    hora = horario.split(":")[0]*60
    minutos = horario.split(":")[1]*1
    auxiliar = hora + minutos

    //Adicionando ou subtraindo
   // if (adiciona){
        auxiliar = auxiliar + minutosAdd
    //} else {
    //    auxiliar = auxiliar - minutosAdd
    //}

    //Voltando para o formato hora:minuto
    hora = Math.floor(auxiliar/60)
    minutos = auxiliar - hora*60
    if (hora < 10) hora = "0" + hora
    if (minutos < 10) minutos = "0" + minutos
    horario = hora + ":" + minutos
    return horario
}

//Fim das funções
//Começando o trabalho pra valer

body = document.getElementsByTagName("body")[0]

encontrado = false; //variável de controle para ver se existe alguma disciplina

//Verificando a existência de disciplinas
tables = document.getElementsByTagName("table")
for (var i=0; i<tables.length;i++){
    tags_tr = tables[i].getElementsByTagName("tr")[0]
    tags_td = tags_tr.getElementsByTagName("td")[0]
    if (tags_td.innerHTML.indexOf("Horário")>0){
        tabela_original = tables[i]
        encontrado = true
    }
}

//Caso tenha sido encontrada alguma disciplina
if (encontrado){

    linhas = tabela_original.getElementsByTagName("tr")

    //Definindo menor e maior horários
    var menor_horario = "23:59"
    var maior_horario = "00:00"
    for (var i=1; i<linhas.length;i++){
        colunas = linhas[i].getElementsByTagName("td")

        inicio = colunas[0].firstChild.firstChild.innerHTML
        menor_horario = compara_horas(menor_horario,inicio,1)

        fim = colunas[1].firstChild.firstChild.innerHTML
        maior_horario = compara_horas(maior_horario,fim,0)
    }

	//Criando a div principal que abrigará todas as outras
    nova_grade = document.createElement('div')
    nova_grade.setAttribute("id", "grade-horaria")
    nova_grade.style.width = LARGURA * 6.5 + "px"
    nova_grade.style.position = "relative"
    nova_grade.style.fill = "true"
    nova_grade.style.border = "thin solid"
    
    base_inicio = adicionaMinutos(menor_horario,0)
    base_fim = adicionaMinutos(maior_horario,60)
    altura_maxima = timestr_to_pixels(adicionaMinutos(base_fim,70)) - timestr_to_pixels(base_inicio)
    nova_grade.style.height = altura_maxima + "px"

    //Adicionando a primeira linha, que contém os dias da semana
	div_dias_semana = document.createElement('div')
	div_dias_semana.setAttribute('id', 'dias_da_semana')
    dia = ["Segunda", "Terça", "Quarta", "Quinta", "Sexta", "Sábado"]
    inicio_dias = adicionaMinutos(menor_horario, -50)
    fim_dias = adicionaMinutos(menor_horario, -20)
    for (var i=0; i<6; i++){
        adiciona_div(div_dias_semana, i, inicio_dias, fim_dias, "<small><center>"+dia[i]+"</center></small>", "#EEE", false, false)
    }
    nova_grade.appendChild(div_dias_semana)

    //Acertando os tracejados
    primeiro_tracejado = menor_horario.split(":")[0]
    ultimo_tracejado = maior_horario.split(":")[0]*1 + 1
    tracejado_horas(primeiro_tracejado,ultimo_tracejado)

	//*
    // Inserindo as disciplinas
    for (var i=1; i<linhas.length;i++){
        colunas = linhas[i].getElementsByTagName("td")
        inicio = colunas[0].firstChild.firstChild.innerHTML
        fim = colunas[1].firstChild.firstChild.innerHTML
        for (var j=2; j<=7;j++){
            html = colunas[j].firstChild.firstChild.innerHTML
            if (html.indexOf("-")>0) {
				adiciona_evento(nova_grade, j-2, inicio, fim, formata_disciplina(html))
			}
        }
    }
	//*/

    pai = tabela_original.parentNode
    pai.replaceChild(nova_grade, tabela_original)
}
















